-- LUA parser for an XAP message

msg=
{
  ["xap-header"] = {
    uid = "FF.9192:00", 
    source = "UKUSA.MOBOTIX.MX12USA", 
    hop = "1", 
    class = "xAPBSC.event", 
    v = "13", 
  },
  ["output.state"] = {
    state = "Off", 
    text = "92220", 
  }
}

function encodeXap(msg)
  local function encodeSection(s)
    local t,v
    t = s..'\n{\n'
    for k,v in pairs(msg[s]) do
      t = t..k.."="..v.."\n"
    end
    t = t..'}\n'
    return t
  end

  local header = 'xap-header'
  if msg[header] == nil then type = 'xap-hbeat' end    
  local out = encodeSection(header)
  for k,_ in pairs(msg) do
    if k ~= header then
      out = out .. encodeSection(k)
    end
  end

  return out
end

print(encodeXap(msg))

